<!DOCTYPE html>

<html lang="en" data-content_root="../../">
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>helpers.preprocessing &#8212; NLP004  documentation</title>
    <link rel="stylesheet" type="text/css" href="../../_static/pygments.css?v=4f649999" />
    <link rel="stylesheet" type="text/css" href="../../_static/alabaster.css?v=039e1c02" />
    <script src="../../_static/documentation_options.js?v=5929fcd5"></script>
    <script src="../../_static/doctools.js?v=888ff710"></script>
    <script src="../../_static/sphinx_highlight.js?v=dc90522c"></script>
    <link rel="index" title="Index" href="../../genindex.html" />
    <link rel="search" title="Search" href="../../search.html" />
   
  <link rel="stylesheet" href="../../_static/custom.css" type="text/css" />
  
  
  <meta name="viewport" content="width=device-width, initial-scale=0.9, maximum-scale=0.9" />

  </head><body>
  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          

          <div class="body" role="main">
            
  <h1>Source code for helpers.preprocessing</h1><div class="highlight"><pre>
<span></span><span class="kn">import</span> <span class="nn">sys</span>
<span class="kn">import</span> <span class="nn">string</span>
<span class="kn">import</span> <span class="nn">re</span>
<span class="kn">import</span> <span class="nn">nltk</span>
<span class="kn">from</span> <span class="nn">nltk.corpus</span> <span class="kn">import</span> <span class="n">stopwords</span>
<span class="kn">from</span> <span class="nn">nltk.tokenize</span> <span class="kn">import</span> <span class="n">word_tokenize</span>
<span class="kn">from</span> <span class="nn">nltk.stem.porter</span> <span class="kn">import</span> <span class="n">PorterStemmer</span>
<span class="kn">from</span> <span class="nn">nltk.stem</span> <span class="kn">import</span> <span class="n">WordNetLemmatizer</span>

<div class="viewcode-block" id="clean_new_lines">
<a class="viewcode-back" href="../../helpers/preprocessing.html#helpers.preprocessing.clean_new_lines">[docs]</a>
<span class="k">def</span> <span class="nf">clean_new_lines</span><span class="p">(</span><span class="n">text</span><span class="p">):</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Removes new lines from the text.</span>

<span class="sd">    Arguments:</span>

<span class="sd">        text (str): Input text needed to be cleaned/</span>

<span class="sd">    Returns:</span>

<span class="sd">        str: String text with no new lines.</span>
<span class="sd">    &quot;&quot;&quot;</span>

    <span class="k">return</span> <span class="n">text</span><span class="o">.</span><span class="n">replace</span><span class="p">(</span><span class="s1">&#39;</span><span class="se">\n</span><span class="s1">&#39;</span><span class="p">,</span> <span class="s1">&#39;&#39;</span><span class="p">)</span></div>


<div class="viewcode-block" id="clean_white_spaces">
<a class="viewcode-back" href="../../helpers/preprocessing.html#helpers.preprocessing.clean_white_spaces">[docs]</a>
<span class="k">def</span> <span class="nf">clean_white_spaces</span><span class="p">(</span><span class="n">text</span><span class="p">):</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Removes redundant white spaces.</span>

<span class="sd">    Arguments:</span>

<span class="sd">        text (str): Input text needed to be cleaned.</span>

<span class="sd">    Returns:</span>

<span class="sd">        str: String text with single  white spaces, instead of multiple.</span>
<span class="sd">    &quot;&quot;&quot;</span>

    <span class="k">return</span> <span class="s1">&#39; &#39;</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">text</span><span class="o">.</span><span class="n">split</span><span class="p">())</span></div>


<div class="viewcode-block" id="lowercase_text">
<a class="viewcode-back" href="../../helpers/preprocessing.html#helpers.preprocessing.lowercase_text">[docs]</a>
<span class="k">def</span> <span class="nf">lowercase_text</span><span class="p">(</span><span class="n">text</span><span class="p">):</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Turn the text into lowercase.</span>

<span class="sd">    Arguments:</span>

<span class="sd">        text (str): Input text needed to be turned into lowercase.</span>

<span class="sd">    Returns:</span>

<span class="sd">        str: Text in lower case.</span>
<span class="sd">    &quot;&quot;&quot;</span>

    <span class="k">return</span> <span class="n">text</span><span class="o">.</span><span class="n">lower</span><span class="p">()</span></div>


<div class="viewcode-block" id="translate_interval_dash">
<a class="viewcode-back" href="../../helpers/preprocessing.html#helpers.preprocessing.translate_interval_dash">[docs]</a>
<span class="k">def</span> <span class="nf">translate_interval_dash</span><span class="p">(</span><span class="n">text</span><span class="p">):</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Translates dashes, showing intervals (e.g. 100-200) into white spaces.</span>

<span class="sd">    Arguments:</span>

<span class="sd">        text (str): Input text with dashes.</span>

<span class="sd">    Returns:</span>

<span class="sd">        str: Text with no dashes.</span>
<span class="sd">    &quot;&quot;&quot;</span>

    <span class="n">pattern</span> <span class="o">=</span> <span class="sa">r</span><span class="s1">&#39;(\d+)(-|–)(\d+)&#39;</span>

    <span class="k">def</span> <span class="nf">matcher</span><span class="p">(</span><span class="n">match</span><span class="p">):</span>
        <span class="k">return</span> <span class="n">match</span><span class="o">.</span><span class="n">group</span><span class="p">(</span><span class="mi">1</span><span class="p">)</span> <span class="o">+</span> <span class="s1">&#39; &#39;</span> <span class="o">+</span> <span class="n">match</span><span class="o">.</span><span class="n">group</span><span class="p">(</span><span class="mi">3</span><span class="p">)</span>

    <span class="k">return</span> <span class="n">re</span><span class="o">.</span><span class="n">sub</span><span class="p">(</span><span class="n">pattern</span><span class="p">,</span> <span class="n">matcher</span><span class="p">,</span> <span class="n">text</span><span class="p">)</span></div>


<div class="viewcode-block" id="remove_puntuation">
<a class="viewcode-back" href="../../helpers/preprocessing.html#helpers.preprocessing.remove_puntuation">[docs]</a>
<span class="k">def</span> <span class="nf">remove_puntuation</span><span class="p">(</span><span class="n">text</span><span class="p">):</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Removes punctuation marks from the text.</span>

<span class="sd">    Arguments:</span>

<span class="sd">        text (str): Input text with punctuation marks.</span>

<span class="sd">    Returns:</span>

<span class="sd">        str: Text with no punctuation marks.</span>
<span class="sd">    &quot;&quot;&quot;</span>

    <span class="n">translator</span> <span class="o">=</span> <span class="nb">str</span><span class="o">.</span><span class="n">maketrans</span><span class="p">(</span><span class="s1">&#39;&#39;</span><span class="p">,</span> <span class="s1">&#39;&#39;</span><span class="p">,</span> <span class="n">string</span><span class="o">.</span><span class="n">punctuation</span><span class="p">)</span>
    <span class="k">return</span> <span class="n">text</span><span class="o">.</span><span class="n">translate</span><span class="p">(</span><span class="n">translator</span><span class="p">)</span></div>


<div class="viewcode-block" id="tokenize_if_string">
<a class="viewcode-back" href="../../helpers/preprocessing.html#helpers.preprocessing.tokenize_if_string">[docs]</a>
<span class="k">def</span> <span class="nf">tokenize_if_string</span><span class="p">(</span><span class="n">text</span><span class="p">):</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    If input is string, tokenizes with word_tokenize from nltk. Used in other functions, when input isn&#39;t tokenized list but is string.</span>

<span class="sd">    Arguments:</span>

<span class="sd">        text (str/list): Input text.</span>

<span class="sd">    Returns:</span>

<span class="sd">        list: tokenized words</span>
<span class="sd">    &quot;&quot;&quot;</span>

    <span class="k">if</span><span class="p">(</span><span class="nb">type</span><span class="p">(</span><span class="n">text</span><span class="p">)</span> <span class="o">==</span> <span class="nb">str</span><span class="p">):</span>
        <span class="k">return</span> <span class="n">word_tokenize</span><span class="p">(</span><span class="n">text</span><span class="p">)</span>

    <span class="k">return</span> <span class="n">text</span></div>


<div class="viewcode-block" id="clean_stop_words">
<a class="viewcode-back" href="../../helpers/preprocessing.html#helpers.preprocessing.clean_stop_words">[docs]</a>
<span class="k">def</span> <span class="nf">clean_stop_words</span><span class="p">(</span><span class="n">text</span><span class="p">,</span> <span class="n">language</span><span class="o">=</span><span class="s1">&#39;english&#39;</span><span class="p">):</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Removes stop words (e.g. the, a, or, do, etc.).</span>

<span class="sd">    Arguments:</span>

<span class="sd">        text (str/list): Input string with stop words. Can be list, if already tokenized.</span>

<span class="sd">        language (str): Language of text and stop words. Defaults to &#39;english&#39;.</span>

<span class="sd">    Returns:</span>

<span class="sd">        list: List of strings, each one being words, which are not stop words.</span>
<span class="sd">    &quot;&quot;&quot;</span>

    <span class="n">stop_words</span> <span class="o">=</span> <span class="nb">set</span><span class="p">(</span><span class="n">stopwords</span><span class="o">.</span><span class="n">words</span><span class="p">(</span><span class="n">language</span><span class="p">))</span>
    <span class="n">tokens</span> <span class="o">=</span> <span class="n">tokenize_if_string</span><span class="p">(</span><span class="n">text</span><span class="p">)</span>
    <span class="n">clean_text</span> <span class="o">=</span> <span class="p">[</span><span class="n">word</span> <span class="k">for</span> <span class="n">word</span> <span class="ow">in</span> <span class="n">tokens</span> <span class="k">if</span> <span class="n">word</span> <span class="ow">not</span> <span class="ow">in</span> <span class="n">stop_words</span><span class="p">]</span>

    <span class="k">return</span> <span class="n">clean_text</span></div>


<div class="viewcode-block" id="stem_words">
<a class="viewcode-back" href="../../helpers/preprocessing.html#helpers.preprocessing.stem_words">[docs]</a>
<span class="k">def</span> <span class="nf">stem_words</span><span class="p">(</span><span class="n">text</span><span class="p">):</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Stemms words in text.</span>

<span class="sd">    Arguments:</span>

<span class="sd">        text (str/list): Input text. Can be string or list of strings.</span>

<span class="sd">    Returns:</span>

<span class="sd">        list: List of strings, each one being a stem of a word.</span>
<span class="sd">    &quot;&quot;&quot;</span>

    <span class="n">tokenized_text</span> <span class="o">=</span> <span class="n">tokenize_if_string</span><span class="p">(</span><span class="n">text</span><span class="p">)</span>

    <span class="n">stemmer</span> <span class="o">=</span> <span class="n">PorterStemmer</span><span class="p">()</span>

    <span class="n">word_stems</span> <span class="o">=</span> <span class="p">[</span><span class="n">stemmer</span><span class="o">.</span><span class="n">stem</span><span class="p">(</span><span class="n">word</span><span class="p">)</span> <span class="k">for</span> <span class="n">word</span> <span class="ow">in</span> <span class="n">tokenized_text</span><span class="p">]</span>

    <span class="k">return</span> <span class="n">word_stems</span></div>


<div class="viewcode-block" id="lem_words">
<a class="viewcode-back" href="../../helpers/preprocessing.html#helpers.preprocessing.lem_words">[docs]</a>
<span class="k">def</span> <span class="nf">lem_words</span><span class="p">(</span><span class="n">text</span><span class="p">):</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Lemms words in text.</span>

<span class="sd">    Arguments:</span>

<span class="sd">        text (str/list): Input text. Can be string or list of strings.</span>

<span class="sd">    Returns:</span>

<span class="sd">        list: List of strings, each one being a lemma of a word.</span>
<span class="sd">    &quot;&quot;&quot;</span>

    <span class="n">tokenized_words</span> <span class="o">=</span> <span class="n">tokenize_if_string</span><span class="p">(</span><span class="n">text</span><span class="p">)</span>

    <span class="n">lemmatizer</span> <span class="o">=</span> <span class="n">WordNetLemmatizer</span><span class="p">()</span>

    <span class="n">lemmatized_words</span> <span class="o">=</span> <span class="p">[</span><span class="n">lemmatizer</span><span class="o">.</span><span class="n">lemmatize</span><span class="p">(</span><span class="n">word</span><span class="p">)</span> <span class="k">for</span> <span class="n">word</span> <span class="ow">in</span> <span class="n">tokenized_words</span><span class="p">]</span>

    <span class="k">return</span> <span class="n">lemmatized_words</span></div>


<div class="viewcode-block" id="cut_text_on_phrase">
<a class="viewcode-back" href="../../helpers/preprocessing.html#helpers.preprocessing.cut_text_on_phrase">[docs]</a>
<span class="k">def</span> <span class="nf">cut_text_on_phrase</span><span class="p">(</span><span class="n">text</span><span class="p">,</span> <span class="n">phrase</span><span class="p">):</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Cuts the text at the given phrase.</span>

<span class="sd">    Arguments:</span>
<span class="sd">        </span>
<span class="sd">        text (str): Input text.</span>

<span class="sd">        phrase (str): The phrase, at which text has to be cut.</span>

<span class="sd">    Returns:</span>

<span class="sd">        str: The text from begining until the position of the phrase.</span>
<span class="sd">    &quot;&quot;&quot;</span>

    <span class="n">phrase_index</span> <span class="o">=</span> <span class="n">text</span><span class="o">.</span><span class="n">find</span><span class="p">(</span><span class="n">phrase</span><span class="p">)</span>

    <span class="k">if</span> <span class="n">phrase_index</span><span class="o">!=-</span><span class="mi">1</span><span class="p">:</span>
        <span class="k">return</span> <span class="n">text</span><span class="p">[:</span><span class="n">phrase_index</span><span class="p">]</span>
    <span class="k">else</span><span class="p">:</span>
        <span class="k">return</span> <span class="n">text</span></div>

    
<div class="viewcode-block" id="remove_first_line">
<a class="viewcode-back" href="../../helpers/preprocessing.html#helpers.preprocessing.remove_first_line">[docs]</a>
<span class="k">def</span> <span class="nf">remove_first_line</span><span class="p">(</span><span class="n">text</span><span class="p">):</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Removes first line from text.</span>

<span class="sd">    Arguments:</span>

<span class="sd">        text (str): Input text.</span>

<span class="sd">    Returns:</span>

<span class="sd">        str: The text withput first line.</span>
<span class="sd">    &quot;&quot;&quot;</span>

    <span class="n">lines</span> <span class="o">=</span> <span class="n">text</span><span class="o">.</span><span class="n">splitlines</span><span class="p">()</span>
    <span class="k">if</span> <span class="nb">len</span><span class="p">(</span><span class="n">lines</span><span class="p">)</span> <span class="o">&gt;</span> <span class="mi">1</span><span class="p">:</span>
        <span class="k">return</span> <span class="s1">&#39;</span><span class="se">\n</span><span class="s1">&#39;</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">lines</span><span class="p">[</span><span class="mi">1</span><span class="p">:])</span>
    <span class="k">else</span><span class="p">:</span>
        <span class="k">return</span> <span class="s1">&#39;&#39;</span></div>


<div class="viewcode-block" id="preprocessing_pipeline">
<a class="viewcode-back" href="../../helpers/preprocessing.html#helpers.preprocessing.preprocessing_pipeline">[docs]</a>
<span class="k">def</span> <span class="nf">preprocessing_pipeline</span><span class="p">(</span><span class="n">text</span><span class="p">,</span> <span class="n">stop_words_lang</span><span class="o">=</span><span class="s1">&#39;english&#39;</span><span class="p">,</span> <span class="n">keep_stop_words</span><span class="o">=</span><span class="kc">False</span><span class="p">):</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Performs preprocessing and cleaning on raw input text</span>

<span class="sd">    Arguments:</span>

<span class="sd">        text (str):  Text input.</span>

<span class="sd">        stop_words_lang (str): Language for stop words. Defaults to &#39;english&#39;.</span>

<span class="sd">        keep_stop_words (bool): Defines if stop words should be kept. Defaults to False</span>

<span class="sd">    Returns:</span>

<span class="sd">        list: Tokens of words.</span>

<span class="sd">        list: Stemmed tokens of words.</span>

<span class="sd">        list: Lemmatized tokens of words.</span>
<span class="sd">    &quot;&quot;&quot;</span>

    <span class="n">tmp_text</span> <span class="o">=</span> <span class="n">text</span>

    <span class="n">tmp_text</span> <span class="o">=</span> <span class="n">clean_new_lines</span><span class="p">(</span><span class="n">tmp_text</span><span class="p">)</span>
    <span class="n">tmp_text</span> <span class="o">=</span> <span class="n">clean_white_spaces</span><span class="p">(</span><span class="n">tmp_text</span><span class="p">)</span>
    <span class="n">tmp_text</span> <span class="o">=</span> <span class="n">lowercase_text</span><span class="p">(</span><span class="n">tmp_text</span><span class="p">)</span>
    <span class="n">tmp_text</span> <span class="o">=</span> <span class="n">translate_interval_dash</span><span class="p">(</span><span class="n">tmp_text</span><span class="p">)</span>
    <span class="n">tmp_text</span> <span class="o">=</span> <span class="n">remove_puntuation</span><span class="p">(</span><span class="n">tmp_text</span><span class="p">)</span>

    <span class="n">tokenized</span> <span class="o">=</span> <span class="n">tokenize_if_string</span><span class="p">(</span><span class="n">tmp_text</span><span class="p">)</span>

    <span class="k">if</span> <span class="p">(</span><span class="ow">not</span> <span class="n">keep_stop_words</span><span class="p">):</span>
        <span class="n">tokenized</span> <span class="o">=</span> <span class="n">clean_stop_words</span><span class="p">(</span><span class="n">tokenized</span><span class="p">,</span> <span class="n">stop_words_lang</span><span class="p">)</span>

    <span class="n">stemmed_tokens</span> <span class="o">=</span> <span class="n">stem_words</span><span class="p">(</span><span class="n">tokenized</span><span class="p">)</span>
    <span class="n">lemmatized_tokens</span> <span class="o">=</span> <span class="n">lem_words</span><span class="p">(</span><span class="n">tokenized</span><span class="p">)</span>

    <span class="k">return</span> <span class="n">tokenized</span><span class="p">,</span> <span class="n">stemmed_tokens</span><span class="p">,</span> <span class="n">lemmatized_tokens</span></div>







</pre></div>

          </div>
          
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
<h1 class="logo"><a href="../../index.html">NLP004</a></h1>








<h3>Navigation</h3>
<p class="caption" role="heading"><span class="caption-text">Contents:</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../modules.html">python</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../pipe.html">pipe</a></li>
</ul>

<div class="relations">
<h3>Related Topics</h3>
<ul>
  <li><a href="../../index.html">Documentation overview</a><ul>
  <li><a href="../index.html">Module code</a><ul>
  </ul></li>
  </ul></li>
</ul>
</div>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="../../search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" autocomplete="off" autocorrect="off" autocapitalize="off" spellcheck="false"/>
      <input type="submit" value="Go" />
    </form>
    </div>
</div>
<script>document.getElementById('searchbox').style.display = "block"</script>








        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="footer">
      &copy;2023, Ughur Mammadzada.
      
      |
      Powered by <a href="http://sphinx-doc.org/">Sphinx 7.2.6</a>
      &amp; <a href="https://github.com/bitprophet/alabaster">Alabaster 0.7.13</a>
      
    </div>

    

    
  </body>
</html>